Attribute VB_Name = "modWinInet"
Option Explicit
' Initializes an application's use of the Win32 Internet functions
Public Declare Function InternetOpen Lib "wininet.dll" Alias "InternetOpenA" _
(ByVal sAgent As String, ByVal lAccessType As Long, ByVal sProxyName As String, _
ByVal sProxyBypass As String, ByVal lFlags As Long) As Long

' User agent constant.
Public Const scUserAgent = "vb wininet"

' Use registry access settings.
Public Const INTERNET_OPEN_TYPE_PRECONFIG = 0
Public Const INTERNET_OPEN_TYPE_DIRECT = 1
Public Const INTERNET_OPEN_TYPE_PROXY = 3
Public Const INTERNET_INVALID_PORT_NUMBER = 0

Public Const FTP_TRANSFER_TYPE_ASCII = &H1
Public Const FTP_TRANSFER_TYPE_BINARY = &H2

' Opens a HTTP session for a given site.
Public Declare Function InternetConnect Lib "wininet.dll" Alias "InternetConnectA" _
(ByVal hInternetSession As Long, ByVal sServerName As String, ByVal nServerPort As Integer, _
ByVal sUsername As String, ByVal sPassword As String, ByVal lService As Long, _
ByVal lFlags As Long, ByVal lContext As Long) As Long

' Closes a single Internet handle or a subtree of Internet handles.
Public Declare Function InternetCloseHandle Lib "wininet.dll" _
(ByVal hInet As Long) As Integer
                
' Number of the TCP/IP port on the server to connect to.
Public Const INTERNET_DEFAULT_FTP_PORT = 21
Public Const INTERNET_DEFAULT_GOPHER_PORT = 70
Public Const INTERNET_DEFAULT_HTTP_PORT = 80
Public Const INTERNET_DEFAULT_HTTPS_PORT = 443
Public Const INTERNET_DEFAULT_SOCKS_PORT = 1080

Public Const INTERNET_OPTION_CONNECT_TIMEOUT = 2
Public Const INTERNET_OPTION_RECEIVE_TIMEOUT = 6
Public Const INTERNET_OPTION_SEND_TIMEOUT = 5

Public Const INTERNET_OPTION_USERNAME = 28
Public Const INTERNET_OPTION_PASSWORD = 29
Public Const INTERNET_OPTION_PROXY_USERNAME = 43
Public Const INTERNET_OPTION_PROXY_PASSWORD = 44

' Type of service to access.
Public Const INTERNET_SERVICE_FTP = 1
Public Const INTERNET_SERVICE_GOPHER = 2
Public Const INTERNET_SERVICE_HTTP = 3

' Opens an HTTP request handle.
Public Declare Function HttpOpenRequest Lib "wininet.dll" Alias "HttpOpenRequestA" _
(ByVal hHttpSession As Long, ByVal sVerb As String, ByVal sObjectName As String, ByVal sVersion As String, _
ByVal sReferer As String, ByVal something As Long, ByVal lFlags As Long, ByVal lContext As Long) As Long

Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000

' Sends the specified request to the HTTP server.
Public Declare Function HttpSendRequest Lib "wininet.dll" Alias "HttpSendRequestA" (ByVal _
hHttpRequest As Long, ByVal sHeaders As String, ByVal lHeadersLength As Long, ByVal sOptional As _
String, ByVal lOptionalLength As Long) As Integer


' Queries for information about an HTTP request.
Public Declare Function HttpQueryInfo Lib "wininet.dll" Alias "HttpQueryInfoA" _
(ByVal hHttpRequest As Long, ByVal lInfoLevel As Long, ByVal sBuffer As Any, _
ByRef lBufferLength As Long, ByRef lIndex As Long) As Integer


' The possible values for the lInfoLevel parameter include:
Public Const HTTP_QUERY_CONTENT_TYPE = 1
Public Const HTTP_QUERY_CONTENT_LENGTH = 5
Public Const HTTP_QUERY_EXPIRES = 10
Public Const HTTP_QUERY_LAST_MODIFIED = 11
Public Const HTTP_QUERY_PRAGMA = 17
Public Const HTTP_QUERY_VERSION = 18
Public Const HTTP_QUERY_STATUS_CODE = 19
Public Const HTTP_QUERY_STATUS_TEXT = 20
Public Const HTTP_QUERY_RAW_HEADERS = 21
Public Const HTTP_QUERY_RAW_HEADERS_CRLF = 22
Public Const HTTP_QUERY_FORWARDED = 30
Public Const HTTP_QUERY_SERVER = 37
Public Const HTTP_QUERY_USER_AGENT = 39
Public Const HTTP_QUERY_SET_COOKIE = 43
Public Const HTTP_QUERY_REQUEST_METHOD = 45
Public Const HTTP_STATUS_DENIED = 401
Public Const HTTP_STATUS_PROXY_AUTH_REQ = 407


Public Declare Function HttpEndRequest Lib "wininet.dll" Alias "HttpEndRequestA" _
(ByVal hHttpRequest As Long, ByVal lpBuffersOut As Long, _
ByVal dwFlags As Long, ByVal dwContext As Long) As Long

'
' INTERNET_NO_CALLBACK - if this value is presented as the dwContext parameter
' then no call-backs will be made for that API
'

Public Const INTERNET_NO_CALLBACK = 0

Public Declare Function InternetOpenUrl Lib "wininet.dll" Alias "InternetOpenUrlA" _
(ByVal hInternetSession As Long, ByVal sUrl As String, _
ByVal sHeaders As String, ByVal lHeadersLength As Long, _
ByVal lFlags As Long, ByVal lContext As Long) As Long


Public Declare Function InternetCanonicalizeUrl Lib "wininet.dll" Alias "InternetCanonicalizeUrlA" _
(ByVal sInString As String, ByVal sOutString As String, _
 ByRef lLen As Long, ByRef dwFlags As Long) As Boolean

Public Function URLEscape(sIn As String) As String
    Dim lLen As Long
    Dim sTemp As String
    Dim bResult As Boolean
    
    sTemp = String(Len(sIn) * 3, " ")
    lLen = Len(sTemp) - 1
    bResult = InternetCanonicalizeUrl(sIn, sTemp, lLen, 0)
    If bResult Then
        URLEscape = Mid(sTemp, 1, lLen)
    End If

End Function

Public Function PostData(sServer As String, sPath As String, sPostContent As String)
    Dim hSession As Long
    Dim hConnect As Long
    Dim hRequest As Long
    Dim bResult As Boolean
    Dim sHeaders As String
    Dim lIndex As Long
    Dim iResult As Integer
    
    Dim lBufferLength As Long
    Dim sBuffer As String
    
    sHeaders = "Content-Type: application/x-www-form-urlencoded"
    
    hSession = InternetOpen("WROX_HTTP_Poster", _
                            INTERNET_OPEN_TYPE_PRECONFIG, _
                            vbNull, _
                            vbNull, _
                            0)
    hConnect = InternetConnect(hSession, _
                            sServer, _
                            INTERNET_DEFAULT_HTTP_PORT, _
                            vbNull, _
                            vbNull, _
                            INTERNET_SERVICE_HTTP, _
                            0, _
                            1)
    hRequest = HttpOpenRequest(hConnect, _
                            "POST", _
                            sPath, _
                            vbNull, _
                            vbNull, _
                            0, _
                            0, _
                            1)
    bResult = HttpSendRequest(hRequest, _
                            sHeaders, _
                            Len(sHeaders), _
                            sPostContent, _
                            Len(sPostContent))
                            
    lIndex = 0
    sBuffer = String(1000, " ")
    lBufferLength = Len(sBuffer) - 1
    bResult = HttpQueryInfo(hRequest, HTTP_QUERY_STATUS_CODE, sBuffer, lBufferLength, lIndex)
    If bResult = True Then
        sBuffer = Mid(sBuffer, 1, lBufferLength)
    End If
    PostData = CInt(sBuffer)
    
    iResult = InternetCloseHandle(hSession)
End Function


